<?php

require_once 'base/GepCtrlencasoliEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 * @author  Setforms
 */
class GepCtrlencasoliEntity extends GepCtrlencasoliEntityBase
{


    const IDATIVO = 'S';
    const SEM_CTRL = 10;


    /**       ok
     * Gera novo codigo para o controle de encaminhamento.
     *
     * @param integer $nrorg Numero da organizacao.
     *
     * @return Ambigous <number, number>
     */
    public static function novoCodigoGepCtrlencasoli($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_CTRLENCASOLI', 10);
        return $codigo;
    }


    /**       ok
     * Insere um novo registro de controle de um encaminhamento.
     *
     * @param integer $codigo       Codigo do controle.
     * @param integer $solicitacao  Numero da solicitacao.
     * @param integer $tiposoli     Numero do tipo da solicitacao.
     * @param integer $situacao     Numero da situacao atual.
     * @param integer $tiposoli_ant Numero do tipo de solicitacao anterior.
     * @param integer $situacao_ant Numero da Situacao anterior.
     * @param integer $nrorg        Numero da Organizacao.
     * @param date    $date         Data da insercao.
     * @param integer $operador     Codigo do operador que fez a insercao.
     *
     * @return boolean
     */
    public function insereControleSoli(
        $codigo, $solicitacao, $tiposoli, $situacao,
        $tiposoli_ant, $situacao_ant,
        $nrorg, $date, $operador)
    {

        try {
            $obj = new self();
            $obj->setNrctrlencasoli($codigo);
            $obj->setNrsolicitacao($solicitacao);
            $obj->setNrtiposolicitacao($tiposoli);
            $obj->setNrsituacao($situacao);
            $obj->setNrtiposoliante($tiposoli_ant);
            $obj->setNrsituacaoante($situacao_ant);
            $obj->setNrorg($nrorg);
            $obj->setIdativo(self::IDATIVO);
            $obj->setDtinclusao($date);
            $obj->setDtultatu($date);
            $obj->setNrorginclusao($nrorg);
            $obj->setCdoperinclusao($operador);
            $obj->setNrorgultatu($nrorg);
            $obj->setCdoperultatu($operador);
            $obj->persist();

            return true;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**      ok
     * Retorna dados do ultimo encaminhamento de uma determinada solicitacao.
     *
     * @param integer $nrorg       N?mero da Organicao.
     * @param integer $solicitacao N?mero da solicitacao.
     *
     * @return Ambigous <boolean, mixed, NULL>
     */
    public function retornaDadosControle($nrorg, $solicitacao){
        $dados = GepCtrlencasoli::consultaControle($nrorg, $solicitacao);

        if ($dados instanceof GepCtrlencasoliEntity) {
            return $dados;
        }

        throw new Exception('GepCtrlencasoliEntity: Nao ha controle para esta solicitacao', self::SEM_CTRL);
    }


    /**  ok
     * Exclui um resgistro de controle da solicitacao.
     *
     * @param integer $nrorg       Numero da Organizacao.
     * @param integer $solicitacao Numero da solicitacao.
     *
     * @return boolean
     */
    public function excluiControle($nrorg, $solicitacao){
        $dados = GepCtrlencasoli::excluiControle($nrorg, $solicitacao);
        return $dados;
    }


    /**     ok
     * Exclui todos os registros de controle da solicitacao.
     *
     * @param integer $nrorg       Numero da Organizacao.
     * @param integer $solicitacao Numero da solicitacao.
     *
     * @return boolean
     */
    public function excluiControles($nrorg, $solicitacao){
        $dados = GepCtrlencasoli::excluiControles($nrorg, $solicitacao);
        return $dados;
    }


}